/*******************************************************************************
 * FoxUIBaseUnlockListWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxUIBaseUnlockListWidget extends FoxUIBaseUnlockWidget within GFxMoviePlayer
    abstract
    native(UI);

var const localized string HeaderLabel;
var const localized string EquipLabel;
var const localized string PurchaseLabel;
var const localized string LockedLabel;
var const localized string EquippedLabel;
var const localized string EquipTooltip;
var const localized string UnequipTooltip;
var const localized string PreviewTooltip;
var const localized string PurchaseTooltip;
var const localized string LockedTooltip;
var protected transient int PendingUnlockID;
var delegate<OnWorkingDialogShow> __OnWorkingDialogShow__Delegate;
var delegate<OnWorkingDialogHide> __OnWorkingDialogHide__Delegate;
var delegate<OnSelectListEntry> __OnSelectListEntry__Delegate;
var delegate<OnSortList> __OnSortList__Delegate;

delegate OnWorkingDialogShow(string StatusText)
{
    //return;    
}

delegate OnWorkingDialogHide()
{
    //return;    
}

delegate OnSelectListEntry(int UnlockID)
{
    //return;    
}

delegate OnSortList()
{
    //return;    
}

function Initialize(FoxPC PlayerController, optional FoxTypes.EFoxUnlockType ContainedUnlockType)
{
    ContainedUnlockType = 0;
    super.Initialize(PlayerController, ContainedUnlockType);
    SetString("listLabel", HeaderLabel);
    ReloadList();
    //return;    
}

function Cleanup()
{
    super.Cleanup();
    PendingUnlockID = 0;
    //return;    
}

// Export UFoxUIBaseUnlockListWidget::execSetListFromUnlocks(FFrame&, void* const)
native function SetListFromUnlocks(optional array<int> Unlocks);

function SetSelectedListItem(int Index)
{
    //return;    
}

protected function ReloadList()
{
    //return;    
}

function int GetIndexFromUnlock(int UnlockID)
{
    return -1;
    //return ReturnValue;    
}

function int GetUnlockFromIndex(int Index)
{
    return 0;
    //return ReturnValue;    
}

protected function SetSelectedListEntry(int Index)
{
    PendingUnlockID = 0;
    OnSelectListEntry(GetUnlockFromIndex(Index));
    //return;    
}

// Export UFoxUIBaseUnlockListWidget::execGetListEntryDetails(FFrame&, void* const)
protected native function bool GetListEntryDetails(out BaseUnlockEntry BaseEntry);

protected function bool GetStoreItemByID(int UnlockID, out StoreMetaData StoreItem)
{
    local FoxItemCacheStore StoreCache;

    return (class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache) && StoreCache.GetCachedItemByUnlockID(StoreItem, UnlockID)) && StoreItem.ItemId == UnlockID;
    //return ReturnValue;    
}

protected function bool GetStoreItemByGuid(string ItemGuid, out StoreMetaData StoreItem)
{
    local FoxItemCacheStore StoreCache;

    return (class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache) && StoreCache.GetCachedItemByGuid(StoreItem, ItemGuid)) && StoreItem.ItemGuid == ItemGuid;
    //return ReturnValue;    
}

protected function bool GetInventoryItemByGuid(string InstanceId, out InventoryMetaData InventoryItem)
{
    local FoxItemCacheInventory InventoryCache;

    return (class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache) && InventoryCache.GetCachedItemByGuid(InventoryItem, InstanceId)) && InventoryItem.InstanceId == InstanceId;
    //return ReturnValue;    
}

protected function RefreshCacheStarted()
{
    //return;    
}

protected function RefreshCacheComplete(bool bResult, const string FailureReason)
{
    local FoxServerConnection ServerConn;
    local FoxItemCacheInventory InventoryCache;
    local array<InventoryMetaData> UpdatedItems;

    // End:0x208
    if((bResult && PCOwner != none) && PCOwner.DynamicUI != none)
    {
        ServerConn = FoxServerConnection(PCOwner.WorldInfo.ServerConn);
        // End:0x208
        if(class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache) && InventoryCache.HasUpdatedItems(UpdatedItems))
        {
            InventoryCache.MergeUpdatedItems();
            ServerConn = FoxServerConnection(PCOwner.WorldInfo.ServerConn);
            // End:0x179
            if(ServerConn != none)
            {
                ServerConn.ApplyInventoryFromCache();
            }
            ReloadList();
            // End:0x208
            if(bWantsEquip)
            {
                switch(PCOwner.DynamicUI.GetItemPurchasedStateFromID(PendingUnlockID))
                {
                    // End:0x1E0
                    case 4:
                    // End:0x205
                    case 3:
                        SetSelectedListItem(GetIndexFromUnlock(PendingUnlockID));
                        // End:0x208
                        break;
                    // End:0xFFFF
                    default:
                    }
                }
            }
            super.RefreshCacheComplete(bResult, FailureReason);
            //return;            
}

protected function CreateActivateItemTask(out FoxActivateItemUI ActivateItemUI, const out array<StoreMetaData> StoreItems, const out array<InventoryMetaData> InventoryItems, optional bool bEquip)
{
    super.CreateActivateItemTask(ActivateItemUI, StoreItems, InventoryItems, bEquip);
    // End:0x9F
    if(ActivateItemUI != none)
    {
        ActivateItemUI.__OnWorkingDialogShow__Delegate = OnWorkingDialogShow;
        ActivateItemUI.__OnWorkingDialogHide__Delegate = OnWorkingDialogHide;
    }
    //return;    
}

protected function CreateDestroyItemTask(out FoxDestroyItemUI DestroyItemUI, const out array<InventoryMetaData> InventoryItems)
{
    super.CreateDestroyItemTask(DestroyItemUI, InventoryItems);
    // End:0x8B
    if(DestroyItemUI != none)
    {
        DestroyItemUI.__OnWorkingDialogShow__Delegate = OnWorkingDialogShow;
        DestroyItemUI.__OnWorkingDialogHide__Delegate = OnWorkingDialogHide;
    }
    //return;    
}

protected function int SortByUnlockID(const int InA, const int InB)
{
    return ((InA <= InB) ? 0 : -1);
    //return ReturnValue;    
}

defaultproperties
{
    EquipTooltip="Equip"
    UnequipTooltip="Unequip"
    PreviewTooltip="Preview"
    PurchaseTooltip="Purchase"
    LockedTooltip="Locked"
}